
#ifndef	__GFXPIXEL_H
#define	__GFXPIXEL_H

class V32 {
private:
	BYTE b,g,r,a;
public:
	inline int GetR(){return r;}
	inline int GetG(){return g;}
	inline int GetB(){return b;}
	inline void SetRGB(int _r,int _g,int _b){r=_r;g=_g;b=_b;}
};

class V24 {
private:
	BYTE b,g,r;
public:
	inline int GetR(){return r;}
	inline int GetG(){return g;}
	inline int GetB(){return b;}
	inline void SetRGB(int _r,int _g,int _b){r=_r;g=_g;b=_b;}
};

class V16g {
private:
	SHORT c;
public:
	inline int GetR(){return (c&0xf800)>>8;}
	inline int GetG(){return (c&0x07e0)>>3;}
	inline int GetB(){return (c&0x001f)<<3;}
	inline void SetRGB(int _r,int _g,int _b){
		c= ( (_b>>3) &0x001f ) |
		   ( (_g<<3) &0x07e0 ) |
		   ( (_r<<8) &0xf800 ) ;
	}
};

class V16 {
private:
	SHORT c;
public:
	inline int GetR(){return (c&0x7c00)>>7;}
	inline int GetG(){return (c&0x03e0)>>2;}
	inline int GetB(){return (c&0x001f)<<3;}
	inline void SetRGB(int _r,int _g,int _b){
		c= ( (_b>>3) &0x001f ) |
		   ( (_g<<2) &0x03e0 ) |
		   ( (_r<<7) &0x7c00 ) ;
	}
};

#endif //__GFXPIXEL_H
